Index: /pykota/trunk/bin/pkbcodes
===================================================================
--- /pykota/trunk/bin/pkbcodes (revision 2340)
+++ /pykota/trunk/bin/pkbcodes (revision 2342)
@@ -104,5 +104,5 @@
             raise PyKotaToolError, "%s : %s" % (pwd.getpwuid(os.geteuid())[0], _("You're not allowed to use this command."))
             
-        if options["list"] and not names :
+        if (options["list"] or options["reset"]) and not names :
             names = ["*"]
             
@@ -113,7 +113,7 @@
                 if billingcode.Exists :
                     if options["skipexisting"] :
-                        self.printInfo(_("Billing code [%s] already exists, skipping.") % billingcode.Name)
+                        self.printInfo(_("Billing code [%s] already exists, skipping.") % billingcode.BillingCode)
                     else :    
-                        self.printInfo(_("Billing code [%s] already exists, will be modified.") % billingcode.Name)
+                        self.printInfo(_("Billing code [%s] already exists, will be modified.") % billingcode.BillingCode)
                         billingcodes.append(billingcode)
                 else :
@@ -133,5 +133,5 @@
             elif options["list"] :    
                 print "%s [%s] %s %s %s %.2f %s" % \
-                      (billingcode.Name, billingcode.Description, \
+                      (billingcode.BillingCode, billingcode.Description, \
                        billingcode.PageCounter, \
                        _("pages"), \
Index: /pykota/trunk/bin/dumpykota
===================================================================
--- /pykota/trunk/bin/dumpykota (revision 2303)
+++ /pykota/trunk/bin/dumpykota (revision 2342)
@@ -56,4 +56,5 @@
                          - pmembers : dumps printer groups members.
                          - umembers : dumps user groups members.
+                         - billingcodes : dumps billing codes.
                          
                        NB : the -d | --data command line option   
Index: /pykota/trunk/man/genman.sh
===================================================================
--- /pykota/trunk/man/genman.sh (revision 2146)
+++ /pykota/trunk/man/genman.sh (revision 2342)
@@ -14,5 +14,5 @@
 # $Id$
 #
-for prog in pkmail pkbanner autopykota dumpykota edpykota pykotme repykota warnpykota pkprinters pkhint pykosd ; do 
+for prog in pkbcodes pkmail pkbanner autopykota dumpykota edpykota pykotme repykota warnpykota pkprinters pkhint pykosd ; do 
     echo $prog ;
     help2man --no-info --section=1 --manual "User Commands" --source="C@LL - Conseil Internet & Logiciels Libres" --output=$prog.1 $prog ; 
Index: /pykota/trunk/NEWS
===================================================================
--- /pykota/trunk/NEWS (revision 2323)
+++ /pykota/trunk/NEWS (revision 2342)
@@ -22,4 +22,9 @@
 PyKota NEWS :
        
+    - 1.23alpha15 :
+    
+        - pkbcodes now works with the PostgreSQL backend.
+          NB : PLEASE RUN upgrade-to-1.23.sql AGAIN !!!
+        
     - 1.23alpha14 : 
     
Index: /pykota/trunk/pykota/dumper.py
===================================================================
--- /pykota/trunk/pykota/dumper.py (revision 2302)
+++ /pykota/trunk/pykota/dumper.py (revision 2342)
@@ -52,4 +52,5 @@
                        "pmembers" : N_("Printers Groups Membership"), 
                        "umembers" : N_("Users Groups Membership"),
+                       "billingcodes" : N_("Billing Codes"),
                      }
     validformats = { "csv" : N_("Comma Separated Values"),
Index: /pykota/trunk/pykota/storages/sql.py
===================================================================
--- /pykota/trunk/pykota/storages/sql.py (revision 2320)
+++ /pykota/trunk/pykota/storages/sql.py (revision 2342)
@@ -24,5 +24,8 @@
 
 from types import StringType
-from pykota.storage import PyKotaStorageError,BaseStorage,StorageObject,StorageUser,StorageGroup,StoragePrinter,StorageJob,StorageLastJob,StorageUserPQuota,StorageGroupPQuota
+from pykota.storage import PyKotaStorageError, BaseStorage, StorageObject, \
+                           StorageUser, StorageGroup, StoragePrinter, \
+                           StorageJob, StorageLastJob, StorageUserPQuota, \
+                           StorageGroupPQuota, StorageBillingCode
 
 class SQLStorage :
@@ -67,4 +70,12 @@
         return self.prepareRawResult(result)
         
+    def extractBillingcodes(self, extractonly={}) :
+        """Extracts all billing codes records."""
+        thefilter = self.createFilter(extractonly)
+        if thefilter :
+            thefilter = "WHERE %s" % thefilter
+        result = self.doRawSearch("SELECT * FROM billingcodes %s ORDER BY id ASC" % thefilter)
+        return self.prepareRawResult(result)
+        
     def extractGroups(self, extractonly={}) :
         """Extracts all group records."""
@@ -206,4 +217,18 @@
             printer.Exists = 1
         return printer    
+        
+    def getBillingCodeFromBackend(self, label) :        
+        """Extracts a billing code information given its name."""
+        code = StorageBillingCode(self, label)
+        result = self.doSearch("SELECT * FROM billingcodes WHERE billingcode=%s LIMIT 1" % self.doQuote(label))
+        if result :
+            fields = result[0]
+            code.ident = fields.get("id")
+            code.BillingCode = fields.get("billingcode", label)
+            code.Description = self.databaseToUserCharset(fields.get("description") or "")
+            code.Balance = fields.get("balance") or 0.0
+            code.PageCounter = fields.get("pagecounter") or 0
+            code.Exists = 1
+        return code    
         
     def getUserPQuotaFromBackend(self, user, printer) :        
@@ -329,4 +354,21 @@
                     self.cacheEntry("PRINTERS", printer.Name, printer)
         return printers        
+        
+    def getMatchingBillingCodes(self, billingcodepattern) :
+        """Returns the list of all billing codes for which the label matches a certain pattern."""
+        codes = []
+        result = self.doSearch("SELECT * FROM billingcodes")
+        if result :
+            for record in result :
+                if self.tool.matchString(record["billingcode"], billingcodepattern.split(",")) :
+                    code = StorageBillingCode(self, record["billingcode"])
+                    code.ident = record.get("id")
+                    code.Balance = record.get("balance") or 0.0
+                    code.PageCounter = record.get("pagecounter") or 0
+                    code.Description = self.databaseToUserCharset(record.get("description") or "") 
+                    code.Exists = 1
+                    codes.append(code)
+                    self.cacheEntry("BILLINGCODES", code.BillingCode, code)
+        return codes        
         
     def getPrinterUsersAndQuotas(self, printer, names=["*"]) :        
@@ -376,11 +418,16 @@
         return self.getPrinter(printername)
         
+    def addBillingCode(self, label) :        
+        """Adds a billing code to the quota storage, returns it."""
+        self.doModify("INSERT INTO billingcodes (billingcode) VALUES (%s)" % self.doQuote(label))
+        return self.getBillingCode(label)
+        
     def addUser(self, user) :        
-        """Adds a user to the quota storage, returns its id."""
+        """Adds a user to the quota storage, returns it."""
         self.doModify("INSERT INTO users (username, limitby, balance, lifetimepaid, email, overcharge) VALUES (%s, %s, %s, %s, %s, %s)" % (self.doQuote(user.Name), self.doQuote(user.LimitBy or 'quota'), self.doQuote(user.AccountBalance or 0.0), self.doQuote(user.LifeTimePaid or 0.0), self.doQuote(user.Email), self.doQuote(user.OverCharge)))
         return self.getUser(user.Name)
         
     def addGroup(self, group) :        
-        """Adds a group to the quota storage, returns its id."""
+        """Adds a group to the quota storage, returns it."""
         self.doModify("INSERT INTO groups (groupname, limitby) VALUES (%s, %s)" % (self.doQuote(group.Name), self.doQuote(group.LimitBy or "quota")))
         return self.getGroup(group.Name)
@@ -442,4 +489,16 @@
         """Sets the new page counters permanently for a user print quota."""
         self.doModify("UPDATE userpquota SET pagecounter=%s, lifepagecounter=%s, warncount=0, datelimit=NULL WHERE id=%s" % (self.doQuote(newpagecounter), self.doQuote(newlifepagecounter), self.doQuote(userpquota.ident)))
+       
+    def writeBillingCodeDescription(self, code) :
+        """Sets the new description for a billing code."""
+        self.doModify("UPDATE billingcodes SET description=%s WHERE id=%s" % (self.doQuote(self.userCharsetToDatabase(code.Description or "")), self.doQuote(code.ident)))
+       
+    def setBillingCodeValues(self, code, newbalance, newpagecounter) :    
+        """Sets the new page counter and balance for a billing code."""
+        self.doModify("UPDATE billingcodes SET balance=%s, pagecounter=%s WHERE id=%s" % (self.doQuote(newbalance), self.doQuote(newpagecounter), self.doQuote(code.ident)))
+       
+    def consumeBillingCode(self, code, balance, pagecounter) :
+        """Consumes from a billing code."""
+        self.doModify("UPDATE billingcodes SET balance=balance + %s, pagecounter=pagecounter + %s WHERE id=%s" % (self.doQuote(balance), self.doQuote(pagecounter), self.doQuote(code.ident)))
        
     def decreaseUserAccountBalance(self, user, amount) :    
@@ -593,3 +652,11 @@
                   ] :
             self.doModify(q)
-        
+            
+    def deleteBillingCode(self, code) :    
+        """Completely deletes a billing code from the Quota Storage."""
+        for q in [
+                   "DELETE FROM billingcodes WHERE id=%s" % self.doQuote(code.ident),
+                 ] :  
+            self.doModify(q)
+            
+        
Index: /pykota/trunk/pykota/storage.py
===================================================================
--- /pykota/trunk/pykota/storage.py (revision 2340)
+++ /pykota/trunk/pykota/storage.py (revision 2342)
@@ -431,9 +431,9 @@
         self.Exists = 0
         
-    def reset(self, pagecounter=0, balance=0.0) :    
+    def reset(self, balance=0.0, pagecounter=0) :    
         """Resets the pagecounter and balance for this billing code."""
-        self.parent.setBillingCodeValues(self, pagecounter, balance)
+        self.parent.setBillingCodeValues(self, balance, pagecounter)
+        self.Balance = balance
         self.PageCounter = pagecounter
-        self.Balance = balance
         
     def setDescription(self, description=None) :
@@ -464,5 +464,5 @@
         if self.usecache :
             self.tool.logdebug("Caching enabled.")
-            self.caches = { "USERS" : {}, "GROUPS" : {}, "PRINTERS" : {}, "USERPQUOTAS" : {}, "GROUPPQUOTAS" : {}, "JOBS" : {}, "LASTJOBS" : {} }
+            self.caches = { "USERS" : {}, "GROUPS" : {}, "PRINTERS" : {}, "USERPQUOTAS" : {}, "GROUPPQUOTAS" : {}, "JOBS" : {}, "LASTJOBS" : {}, "BILLINGCODES" : {} }
         
     def close(self) :    
@@ -539,4 +539,12 @@
             self.cacheEntry("LASTJOBS", printer.Name, lastjob)
         return lastjob    
+        
+    def getBillingCode(self, label) :        
+        """Returns the user from cache."""
+        code = self.getFromCache("BILLINGCODES", label)
+        if code is None :
+            code = self.getBillingCodeFromBackend(label)
+            self.cacheEntry("BILLINGCODES", label, code)
+        return code
         
     def getParentPrinters(self, printer) :    
Index: /pykota/trunk/pykota/version.py
===================================================================
--- /pykota/trunk/pykota/version.py (revision 2323)
+++ /pykota/trunk/pykota/version.py (revision 2342)
@@ -22,5 +22,5 @@
 #
 
-__version__ = "1.23alpha14_unofficial"
+__version__ = "1.23alpha15_unofficial"
 
 __doc__ = "PyKota : a complete Printing Quota Solution for CUPS and LPRng."
Index: /pykota/trunk/initscripts/postgresql/pykota-postgresql.sql
===================================================================
--- /pykota/trunk/initscripts/postgresql/pykota-postgresql.sql (revision 2318)
+++ /pykota/trunk/initscripts/postgresql/pykota-postgresql.sql (revision 2342)
@@ -171,5 +171,5 @@
 --
 CREATE TABLE billingcodes (id SERIAL PRIMARY KEY NOT NULL,
-                           label TEXT UNIQUE NOT NULL,
+                           billingcode TEXT UNIQUE NOT NULL,
                            description TEXT,
                            balance FLOAT DEFAULT 0.0,
Index: /pykota/trunk/initscripts/postgresql/upgrade-to-1.23.sql
===================================================================
--- /pykota/trunk/initscripts/postgresql/upgrade-to-1.23.sql (revision 2318)
+++ /pykota/trunk/initscripts/postgresql/upgrade-to-1.23.sql (revision 2342)
@@ -58,4 +58,5 @@
                            balance FLOAT DEFAULT 0.0,
                            pagecounter INT4 DEFAULT 0);
+ALTER TABLE billingcodes RENAME COLUMN label TO billingcode;
 
 REVOKE ALL ON billingcodes FROM public;                        
@@ -64,2 +65,4 @@
 GRANT SELECT, UPDATE ON billingcodes_id_seq TO pykotaadmin;
 GRANT SELECT ON billingcodes TO pykotauser;
+
+
